<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<!-- Font Awesome -->
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Picture</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Ảnh</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-picture-code" placeholder="picture code" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Tên Ảnh</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-picture-name" placeholder="picture name" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Link Ảnh</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-picture-link" placeholder="picture link" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Mô tả</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div class="col-sm-12">
					<button id="save_data" class="btn btn-info">Save Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>ID</th>
					<th>Mã Ảnh</th>
					<th>Tên Ảnh</th>
					<th>Link Ảnh</th>
					<th>Mô tả</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
					<th>Action</th>
					<th>Danh sách Album</th>
				</tr>
		</table>
	</div>
	<!-- Update Order modal -->
	<div>
		<div id="update-picture-modal" class="modal fade" tabindex="-1">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Update Trạng Thái Picture</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<form>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Mã Ảnh</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-maanh" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Tên Ảnh</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-tenanh" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Link Ảnh</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-linkanh" class="form-control">
								</div>
							</div>
							<div class="row form-group">
								<div class="col-sm-3">
									<label>Mô tả</label>
								</div>
								<div class="col-sm-9">
									<input type="text" id="input-update-moTa" class="form-control">
								</div>
							</div>
						</form>
					</div>
					<div class="modal-footer">
						<button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
						<button class="btn btn-primary" id="btn-update-picture">Update Trạng Thái</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<!-- Delete confirm modal -->
	<div>
		<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
			<div class="modal-dialog">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title" id="h5-modal-title">Picture Delete Confirmation</h5>
						<button class="close" data-dismiss="modal">&times;</button>
					</div>
					<div class="modal-body">
						<label>Bạn có chắc chắn muốn xóa Picture này không?</label>
					</div>
					<div class="modal-footer">
						<button class="btn btn-danger" id="btn-confirm-delete-picture">Confirm</button>
						<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
					</div>
				</div>
			</div>
		</div>
	</div>

	<script>
		$(document).ready(function () {
			var gPicture_codes = {
				id: "",
			}
			onPageLoading();
			$("#save_data").on("click", function () {
				onButtonCreateClick(); // this là button được ấn
			});
			// khi ấn sự kiện edit
			$("#user-table").on("click", ".edit-picture", function () {
				onButtonChiTietClick(this); // this là button được ấn
			});
			// khi ấn nút sự kiện update trên modal
			$("#btn-update-picture").on("click", function () {
				onBtnUpdateClick();
			});
			// khi ấn sự kiện delete
			$("#user-table").on("click", ".delete-picture", function () {
				onBtnDeleteConfirmOrderClick(this);
			});
			// khi ấn sự kiện delete
			$("#user-table").on("click", ".btn-album", function () {
				window.location.href = "album_crud.html";
			});
			// gán sự kiện cho nút Delete  (trên modal)
			$("#btn-confirm-delete-picture").on("click", function () {
				onBtnDeletePictureClick();
			});
			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "anhCode" },
					{ "data": "anhName" },
					{ "data": "linkAnh" },
					{ "data": "moTa" },
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
					{ "data": "action" },
					{ "data": "dsalbum" },
				],
				columnDefs: [
					{
						targets: 7,
						defaultContent: '<i class="fas fa-pen text-info edit-picture"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-picture"></i>'
					},
					{
						targets: 8,
						defaultContent: '<button class="btn btn-primary btn-album">Quay về Album</button>'
					}
				]
			})
			function onPageLoading() {
				//gán dữ liệu
				var vUrlString = window.location.href; //đường đẫn gọi đến trang
				var vUrl = new URL(vUrlString);
				var vID = vUrl.searchParams.get("id");
				// validate
				var vValid = kiemtraID(vID);
				if (vValid) {
					// lấy dữ liệu từ server load vào trang

					$.ajax({
						url: "http://localhost:8080/pictures?id=" + vID,
						type: "GET",
						dataType: "json",
						success: function (res) {
							console.log(res);
							table.clear();
							table.rows.add(res);
							table.draw();
						},
						error: function (err) {
							console.log(err.response);
							window.location.href = "album_crud.html";
						}
					})
				}
			}
			//hàm kiểm tra ID
			function kiemtraID(paramID) {
				if (paramID == null || paramID == "") {
					alert("QueryString không có ID");
					window.location.href = "album_crud.html";
					return false;
				}
				return true;
			}
			// Hàm sự kiện thêm voucher
			function onButtonCreateClick() {
				// khai báo dữ liệu
				var vPictureObj = {
					anhCode: "",
					anhName: "",
					linkAnh: "",
					moTa: ""
				}
				// thu thập thông tin 
				getCreateData(vPictureObj);
				// validate
				if (kiemtraCreateData(vPictureObj)) {
					// Tạo mới order
					createPicture(vPictureObj);
				}
			}
			// hàm thu thập thông tin để create order
			function getCreateData(paramObj) {
				paramObj.anhCode = $("#input-picture-code").val();
				paramObj.anhName = $("#input-picture-name").val();
				paramObj.linkAnh = $("#input-picture-link").val();
				paramObj.moTa = $("#input-note").val();
			}
			function kiemtraCreateData(paramObj) {
				if (paramObj.anhCode == "") {
					alert("Bạn điền mã Picture không hợp lệ")
					return false;
				}
				if (paramObj.anhName == "") {
					alert("Bạn điền tên Picture không hợp lệ")
					return false;
				}
				if (paramObj.linkAnh == "") {
					alert("Bạn điền link Picture không hợp lệ")
					return false;
				}
				return true;
			}
			//Hàm tạo đơn mói
			function createPicture(paramObj) {
				var vUrlString = window.location.href; //đường đẫn gọi đến trang
				var vUrl = new URL(vUrlString);
				var vID = vUrl.searchParams.get("id");
				$.ajax({
					url: "http://localhost:8080/pictures/create/" + vID,
					type: 'POST',
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (paramObjVoucher) {
						//hiển thị dữ liệu lên web
						console.log(paramObjVoucher);
						onPageLoading();
						alert("Bạn tạo thành công Picture");
						$("#input-picture-code").val("");
						$("#input-picture-name").val("");
						$("#input-picture-link").val("");
						$("#input-note").val("");
					},
					error: function (error) {
						alert("Bạn tạo  Picture thất bại!");
						console.log(error.responseText)
					}
				});
			}
			// infoFunction sẽ là function các nút cùng gọi
			function onButtonChiTietClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gPicture_codes.id = vOrderData.id;
				// lấy api để load vào modal
				getPicturebyPicutreID();
				$("#update-picture-modal").modal("show");
			}
			function onBtnDeleteConfirmOrderClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gPicture_codes.id = vOrderData.id;
				// lấy api để load vào modal
				$("#delete-confirm-modal").modal("show");
			}
			function onBtnPicturesConfirmOrderClick(paramChiTietButton) {
				//Xác định thẻ tr là cha của nút được chọn
				var vRowSelected = $(paramChiTietButton).parents('tr');
				//Lấy datatable row
				var vDatatableRow = table.row(vRowSelected);
				//Lấy data của dòng 
				var vOrderData = vDatatableRow.data();
				gAlbum_code.id = vOrderData.id;
				// location trang mới
				var vUrlSiteToOpen = "userDetail.html" +
					"?id=" + gAlbum_code.id;
				window.location.href = vUrlSiteToOpen;

			}
			function getPicturebyPicutreID() {
				$.ajax({
					url: "http://localhost:8080/pictures/details/" + gPicture_codes.id,
					type: "GET",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						loadDataToModal(responseObject);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm load data to modal update
			function loadDataToModal(paramResponseObject) {
				$("#input-update-maanh").val(paramResponseObject.anhCode);
				$("#input-update-tenanh").val(paramResponseObject.anhName);
				$("#input-update-linkanh").val(paramResponseObject.linkAnh);
				$("#input-update-moTa").val(paramResponseObject.moTa);
			}
			// khi bấm nút Update trên modal
			function onBtnUpdateClick() {
				console.log(gPicture_codes.id);
				//khai báo dữ liệu
				var vObjectRequest = {
					anhCode: "",
					anhName: "",
					linkAnh: "",
					moTa: ""
				}
				// gán dữ liệu
				vObjectRequest.anhCode = $("#input-update-maanh").val();
				vObjectRequest.anhName = $("#input-update-tenanh").val();
				vObjectRequest.linkAnh = $("#input-update-linkanh").val();
				vObjectRequest.moTa = $("#input-update-moTa").val();
				//validate
				var validate = IstrangThai(vObjectRequest);
				if (validate) {
					//cập nhật trạng thái
					updatePicture(vObjectRequest);
				}
			}
			function IstrangThai(paramObj) {
				if (paramObj.anhCode == "") {
					alert("Bạn điền mã Picture không hợp lệ")
					return false;
				}
				if (paramObj.anhName == "") {
					alert("Bạn điền tên Picture không hợp lệ")
					return false;
				}
				if (paramObj.linkAnh == "") {
					alert("Bạn điền link Picture không hợp lệ")
					return false;
				}
				return true;
			}
			//update Voucher
			function updatePicture(paramObj) {
				$.ajax({
					url: "http://localhost:8080/pictures/update/" + gPicture_codes.id,
					type: "PUT",
					data: JSON.stringify(paramObj),
					contentType: "application/json; charset=utf-8",
					dataType: 'json',
					success: function (responseObject) {
						//debugger;
						handleUpdatetSuccess(responseObject.id);
					},
					error: function (error) {
						console.assert(error.responseText);
					}
				});
			}
			// hàm xử lý sự kiện delete order modal click
			function onBtnDeletePictureClick() {
				//khai báo dữ liệu
				//validate
				//gọi api
				$.ajax({
					url: "http://localhost:8080/pictures/delete/" + gPicture_codes.id,
					type: "DELETE",
					contentType: "application/json; charset=utf-8",
					success: function (paramRes) {
						// B4: xử lý front-end
						handleDeleteVoucherSuccess();
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					}
				});
				//hiển thị thông tin
			}
			// hàm xử lý hiển thị front-end khi update Trạng thái thành công
			function handleUpdatetSuccess(paramObj) {
				onPageLoading();
				alert("Update Picture Id = " + paramObj + " thành công!");
				$("#update-picture-modal").modal("hide");
			}
			// hàm xử lý hiển thị front-end khi sửa voucher thành công
			function handleDeleteVoucherSuccess() {
				onPageLoading();
				alert("Xóa Picture thành công!");
				$("#delete-confirm-modal").modal("hide");
			}


		});

	</script>
</body>

</html>